using System;

namespace ClipboardCopy_VirtualGrid
{
	public class ExternalData
	{
		private int _rowCount;
		private int _colCount;
		private int[,] _data; 
		private int[] rowheight;

		public ExternalData(int rows, int cols)
		{
			_rowCount = rows;
			_colCount = cols;
			_data = new int[_rowCount, _colCount]; 
            rowheight = new int[_rowCount];           

			// Just set the data. 
			for(int i = 0; i < RowCount; ++i)
			{
				for(int j = 0; j < ColCount; ++j)				
					_data[i,j] = 100 * i +j;    		
				rowheight[i] = 5 + i;
			}
		} 

		public virtual int this[int row, int col]
		{
			get{ return _data[row, col];}
			set{ _data[row, col] = value;}
		} 

		public virtual int[] RowHeight
		{
			get{ return rowheight;}
			set{rowheight = value;}
		}

		public virtual int RowCount
		{
			get{return _rowCount;}
		}

		public virtual int ColCount
		{
			get{ return _colCount;}
		}
	}
}
