using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;


namespace ClipboardCopy_VirtualGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private ExternalData _extData;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.HScrollPixel = true;
			this.gridControl1.Location = new System.Drawing.Point(56, 72);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(704, 304);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.ThemesEnabled = true;
			this.gridControl1.VScrollPixel = true;
			this.gridControl1.PrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler(this.gridControl1_PrepareViewStyleInfo);
			this.gridControl1.ClipboardCopy += new Syncfusion.Windows.Forms.Grid.GridCutPasteEventHandler(this.gridControl1_ClipboardCopy);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(776, 397);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		Hashtable ht = new Hashtable();
		private void Form1_Load(object sender, System.EventArgs e)
		{
			//Create a new external datasource with 10 rows and 10 columns.
			this._extData = new ExternalData(100, 8); 

			//Prepare the grid for virtual data.
			gridControl1.ResetVolatileData(); 
					
			gridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler( GridQueryCellInfo);
			gridControl1.QueryRowCount += new GridRowColCountEventHandler( GridQueryRowCount);	
			gridControl1.QueryColCount += new GridRowColCountEventHandler( GridQueryColCount);			
			this.gridControl1.CurrentCell.MoveTo(2,2,GridSetCurrentCellOptions.SetFocus);
			this.gridControl1.Focus();

			for(int i = 1 ; i <= 3; i++)
			{
				this.gridControl1.Rows.Hidden[i + 5] = true;			
			}	
			ht = VisibleRowIndex();
		}

		# region [     Virtual Grid Events      ]
		void GridQueryRowCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = this._extData.RowCount;
			e.Handled = true;
		}

		void GridQueryColCount(object sender, GridRowColCountEventArgs e) 
		{
			e.Count = this._extData.ColCount;
			e.Handled = true;
		}

		void GridQueryCellInfo(object sender, GridQueryCellInfoEventArgs e) 
		{
			if (e.RowIndex > 0 && e.ColIndex > 0)
			{
				e.Style.CellValue = this._extData[e.RowIndex - 1, e.ColIndex - 1];				
				e.Handled = true;
			}
		}	
		# endregion

		private void gridControl1_ClipboardCopy(object sender, Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs e)
		{
			GridRangeInfo range = e.RangeList.ActiveRange;
			if(!range.IsEmpty)
			{
				range = range.ExpandRange(1,1, this.gridControl1.RowCount, this.gridControl1.ColCount);
				string s = "";				
				for(int row = range.Top; row <= range.Bottom; ++row)
				{
					if(!this.gridControl1.Rows.Hidden[row])
					{
						bool firstCol = true;
						for(int col = range.Left; col <= range.Right; ++col)
						{
							if(!this.gridControl1.Cols.Hidden[col])
							{
								if(!firstCol)
									s += "\t";
								else
									firstCol = false;

								if(col == 0)
									col = 1;								
								s += this._extData[row - 1, col - 1];
							}
						}
						s += Environment.NewLine;
					}
				}
				Clipboard.SetDataObject(s);
				e.Handled = true;
			}
		}	
		
		private Hashtable VisibleRowIndex() 
		{
			Hashtable ht = new Hashtable();
			int c = 0;
			int count = 0;
			for (int i = 1; (i <= this._extData.RowCount); i++) 
			{
				if ((this.gridControl1.RowHeights[i] != 0)) 
				{
					c = (c + 1);
					count = c;
					ht.Add(i, count);
				}
			}
			return ht;
		}
	
		private void gridControl1_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
		{			
			if (ht.ContainsKey(e.RowIndex)) 
			{
				if (((int)ht[e.RowIndex] % 2)== 0)
				{
					e.Style.BackColor = Color.AliceBlue;
				}
				else 
				{
					e.Style.BackColor = Color.White;
				}
			}
		}
	}	
}
